var thisServer				= "www";
var GadgetVersion			= 1;
var webView 				= 0;

var ConnectionEstablished	= 0;
var isConnected				= 0;

var ConnectionTime			= 1000; // in ms
var isFirstLoad				= 1;

var minimized 				= 0;
var isDocked 				= false;

var bodyheight_large		= 300;
var bodywidth_large			= 200;
var bodyheight_small		= 200;
var bodywidth_small			= 135;

var noconnecttext			= "Connection Not Found";
var firstloadtext			= "<b>LOADING...</b><br>please wait...";

// 2007.02.05 KJD: Check for connection
// 2007.04.02 KJD: Not used.
var RemoteJSFile			= "http://" + thisServer + ".symantec.com/internetthreatmeter/styles/vista/connection.js";

var GadgetJSFile			= "http://" + thisServer + ".symantec.com/internetthreatmeter/itm.jsp?server=" + thisServer + "&website=vista&search=1&width=200&height=230";

var ExternalJSFile1			= "http://securityresponse.symantec.com/avcenter/js/vir.js";
var ExternalJSFile2			= "http://securityresponse.symantec.com/avcenter/js/advis.js";
var ExternalJSFile3			= "http://securityresponse.symantec.com/avcenter/js/tools.js";

var populated		= 0;
var loaded_js 		= 0;
var loaded_Lnames 	= 0; 
var loaded_Anames 	= 0;
var loaded_Rnames 	= 0;

var BodySize 		= "large";

function CheckVista( checktype )
{
	var loaditems = 0;

	if( checktype == 'start' )
	{
		// 2007.02.05 KJD: Check the connection
		// CheckConnection();

		ConnectionEstablished	= 1;
		isConnected				= 1;
		
		Debug( "CheckVista('start')" );
		
		// show privacy policy
		setTimeout( "ShowPolicy()", 500 );
	}
	else if( checktype == 'load' )
	{
		Debug( "CheckVista('load'), isConnected=" + isConnected );
	
		// 2007.02.05 KJD: Check for Connection
		if( isConnected ) 
		{
			Debug( "CheckVista('load'), populated1=" + populated );
		
			// 2007.04.03 KJD: Check for loaded vars
			if( !( populated ) )
			{
				PopulateGadget();
				Debug( "CheckVista('load'), populated2=" + populated );
			}
		
			if( window.symITM_JS_loaded )
			{
				//itm_inVista = 1;
				loaditems++;
				
				loaded_js 		= 1;
				Debug( "CheckVista('load'), loaded_js=" + loaded_js );
			}
			
			// 2006.12.22 KJD: For threats
			if( window.symLnames )
			{
				loaditems++;
				loaded_Lnames 	= 1;
				Debug( "CheckVista('load'), Lnames" );
			}
			
			// 2006.12.27 KJD: For Vulnerabilities
			if( window.symAnames )
			{
				loaditems++;
				loaded_Anames 	= 1;
				Debug( "CheckVista('load'), Anames" );
			}

			// 2006.12.27 KJD: For removal tools
			if( window.symRnames )
			{
				loaditems++;
				loaded_Rnames 	= 1;
				Debug( "CheckVista('load'), Rnames" );
			}
			
			
			// if( loaditems != 4 )
			if( 
				!( populated 		) ||
				!( loaded_js 		) ||
				!( loaded_Lnames 	) ||
				!( loaded_Anames 	) ||
				!( loaded_Rnames 	)
			)
			{
				setTimeout( "CheckVista( 'load' )", 250 );
				// Debug( "CheckVista('load'),reload" );
				
				var thisString = "CheckVista('load'), VistaInit";
				thisString += "<br />populated=" + populated;
				thisString += "<br />loaded_js=" + loaded_js;
				thisString += "<br />loaded_Lnames=" + loaded_Lnames;
				thisString += "<br />loaded_Anames=" + loaded_Anames;
				thisString += "<br />loaded_Rnames=" + loaded_Rnames;
				
				Debug( thisString );
			}
			else
			{
				setTimeout( "VistaInit()", 500 );
				Debug( "CheckVista('load'), VistaInit,loaditems=" + loaditems);
			}
		}
		else
		{
			// 2007.02.05 KJD: No Connection
			ShowNoConnection();
			
			Debug( "CheckVista('load'), ShowNoConnection" );
		}
	}
}

// 2007.02.05 KJD: Show no connection
function ShowNoConnection()
{
	Debug( "ShowNoConnection(), isConnected=" + isConnected );

	if( !( isConnected ) )
	{
		Debug( "ShowNoConnection(), checkState" );
		
		checkState();
		
		Debug( "ShowNoConnection(), isFirstLoad=" + isFirstLoad );
		
		if( isFirstLoad )
		{
			noconnecttext = firstloadtext;
			isFirstLoad = 0;
		}

		var classsize = "large";
		if( minimized )
		{
			var classsize = "mini";
		}

		document.getElementById('gadgetwindow').innerHTML = "<DIV CLASS='noconnection_" + classsize + "'>" + noconnecttext + "</DIV>";

		ClearElements();

		Debug( "ShowNoConnection(), ClearElements" );
		
		setTimeout( "CheckVista( 'load' )", 500 );
	}
	else
	{
	}
}

function ClearElements()
{
	Debug( "ClearElements()" );

	populated = 0;
	loaditems = 0;
	
	document.getElementById( 'topbuttons' ).innerHTML 			= "";
	document.getElementById( 'VistaGadgetElements' ).innerHTML 	= "";
	document.getElementById( 'test_flyout' ).innerHTML 			= "";

	try{document.getElementById( 'icons' ).innerHTML 				= "";}catch(e){}
	try{document.getElementById( 'drawerframe' ).innerHTML 			= "";}catch(e){}
	try{document.getElementById( 'symantec_itm_box' ).innerHTML 	= "";}catch(e){}
	
	System.Gadget.settingsUI = "";
	
}

// 2007.01.09 KJD: Show privacy policy
function ShowPolicy()
{
	// 2007.04.17 KJD: Also check for settings file
	var SettingsFile	= System.Gadget.path + "//..//SymantecSettings.txt";
	var fs 				= new ActiveXObject( "Scripting.FileSystemObject" );

	if( fs.FileExists( SettingsFile ) )
	{
		policyvar = 1;
		System.Gadget.Settings.write( "privacyNoticeShown", 1 );
	}


	var policyvar = System.Gadget.Settings.read( "privacyNoticeShown" );
	
	Debug( "ShowPolicy, policyvar = " + policyvar );
	
	if( policyvar != 1 )
	{
		document.getElementById('gadgetwindow').className = 'gadgetDisable_mini';
		
		document.body.style.height	= 190;
		document.body.style.width	= 130;
		
		System.Gadget.Flyout.file 	= "privacypolicy.html";
		System.Gadget.Flyout.show 	= true;
		
		System.Gadget.Flyout.onHide = checkpolicy;
	}
	else
	{
		document.getElementById('gadgetwindow').className = 'gadgetDisable';
		
		
		document.body.style.width	= 200;
		document.body.style.height	= 300;
		
		System.Gadget.Flyout.onHide = donothing;

		CheckVista( 'load' );
	}
}

function checkpolicy()
{
	var policyvar = System.Gadget.Settings.read( "privacyNoticeShown" );
	
	if( policyvar == 1 )
	{
		document.getElementById('gadgetwindow').className = 'gadgetDisable';
		
		
		document.body.style.width	= 200;
		document.body.style.height	= 300;
	
		System.Gadget.Flyout.onHide = donothing;

		CheckVista( 'load' );
	}
	else
	{
		setTimeout( "ShowPolicy()", 500 );
	}
}

function donothing(){}

function PopulateGadget()
{
	Debug( "PopulateGadget" );

	var innerdata = ""
		+ "<DIV ID='logolink' CLASS='logolink_large' onMouseOver=\"logolink('over')\" onMouseOut=\"logolink('out')\" onClick=\"logolink('click')\"></DIV>"
		+ "<DIV ID='threatlogolink' CLASS='threatlogolink' onMouseOver=\"threatlogolink('over')\" onMouseOut=\"threatlogolink('out')\" onClick=\"threatlogolink('click')\"></DIV>"

		+ "<DIV ID=\"symantec_itm_box\" CLASS=\"mainbox\">"
		+ "<DIV CLASS='loadingtext'>" + firstloadtext + "</DIV>"
		+ "</DIV>"

		+ "<DIV ID=\"itm_icons\"></DIV>"

		+ "<DIV ID='drawerframe'"
		+ "	STYLE=\""
		+ "		position:	absolute;"
		+ "		top:		290;"
		+ "		right:		7px;"
		+ "		width:		195;"
		+ "		border:		none;"
		+ "	\""
		+ ">"
		+ "	<DIV "
		+ "		ID		= 'drawer' "
		+ "		STYLE	= \""
		+ "			background-color:	#C8C8C8;"
		+ "			color:				white;"
		+ "			position:			absolute;"
		+ "			border:				solid #777777 1px;"
		+ "			border-top:			none;"
		+ "			bottom:				0px;"
		+ "			width:				194px;"
		+ "			height:				140px;"
		+ "			left:				5px;"
		+ "			clip:				rect(150px 250px 350px 0px);"
		+ "		\""
		+ "	>"
		+ "	</DIV>"
		+ "</DIV>";

	document.getElementById('gadgetwindow').innerHTML = innerdata;

	Debug( "PopulateGadget gadgetwindow" );
	
	LoadJSFiles();

	System.Gadget.settingsUI = "settings.html";
	
	// 2007.04.03 KJD: Set populated variable
	populated 	= 1;
}

// 2007.04.03 KJD: Load External JS files
function LoadJSFiles()
{
	Debug( "PopulateGadget include JS files" );

	include_localjs( GadgetJSFile 		);
	include_localjs( ExternalJSFile1 	);
	include_localjs( ExternalJSFile2 	);
	include_localjs( ExternalJSFile3 	);
}

function include_localjs(script_filename)
{
    var html_doc = document.getElementsByTagName('head').item(0);
    var js = document.createElement('script');
    js.setAttribute('language', 'javascript');
    js.setAttribute('type', 'text/javascript');
    js.setAttribute('src', script_filename);
    html_doc.appendChild(js);
	return false;
}


// 2007.02.05 KJD: Set status of connection
function ConnectionStatus()
{
	// 2007.04.03 KJD: Override
	ConnectionEstablished = 1;

	if( !( ConnectionEstablished ) )
	{
		Debug( "ConnectionStatus, Not Connected" );
		isConnected 		= 0;
	}
	else
	{
		Debug( "ConnectionStatus, Connected" );
		isConnected 		= 1;
	}
}

///////////////////////////////////////////////////////////////////////////////
// CheckConnection	Check the connection state
// Author: 			Kevin De Angelis
// Date: 			2007.02.05
// Receive: 		null
// Return: 			null
///////////////////////////////////////////////////////////////////////////////
function CheckConnection()
{
	Debug( "CheckConnection" );
	// 2007.04.03 KJD: Override
	ConnectionEstablished = 1;
}

///////////////////////////////////////////////////////////////////////////////
// CheckStates		Apply listener to the gadget
// Author: 			Kevin De Angelis
// Date: 			2007.02.02
// Receive: 		null
// Return: 			null
///////////////////////////////////////////////////////////////////////////////
function CheckStates()
{
	System.Gadget.onUndock 			= checkState;
	System.Gadget.onDock 			= checkState;
	
	Debug( "CheckStates, checkState=" + checkState );
}

///////////////////////////////////////////////////////////////////////////////
// checkState		Check the state of the gadget
// Author: 			Kevin De Angelis
// Date: 			2007.02.02
// Receive: 		null
// Return: 			null
///////////////////////////////////////////////////////////////////////////////
function checkState()
{
    if (!System.Gadget.docked)
    {
        undockedState();
    }
    else
    {
        dockedState();
    }
	
	Debug( "checkState, docked=" + System.Gadget.docked );
}

///////////////////////////////////////////////////////////////////////////////
// undockedState	Actions to perform when the Gadget is undocked
// Author: 			Kevin De Angelis
// Date: 			2007.02.02
// Receive: 		null
// Return: 			null
///////////////////////////////////////////////////////////////////////////////
function undockedState()
{
	if( isConnected )
	{
		setWindowSize( 'large' );
	}
	else
	{
		SetBodySize('large');
		document.getElementById('gadgetwindow').className = "gadgetDisable";
		
		document.getElementById('gadgetwindow').style.width = bodywidth_large;
	}
	
	minimized 	= 0;
	isDocked 	= false;
}

///////////////////////////////////////////////////////////////////////////////
// dockedState		Actions to perform when the Gadget is docked
// Author: 			Kevin De Angelis
// Date: 			2007.02.02
// Receive: 		null
// Return: 			null
///////////////////////////////////////////////////////////////////////////////
function dockedState()
{
	if( isConnected )
	{
		setWindowSize( 'mini' );
	}
	else
	{
		document.getElementById('gadgetwindow').className = "gadgetDisable_mini";
		SetBodySize('small');
		
		document.getElementById('gadgetwindow').style.width = bodywidth_small;
	}
	
	minimized 	= 1;
	isDocked 	= true;
}

///////////////////////////////////////////////////////////////////////////////
// SetBodySize		Set the size of the document body
// Author: 			Kevin De Angelis
// Date: 			2007.02.05
// Receive: 		string
// Return: 			null
///////////////////////////////////////////////////////////////////////////////
function SetBodySize( bodytype )
{
	var bodyheight 	= bodyheight_large;
	var bodywidth	= bodywidth_large;
		
	if( bodytype == 'small' )
	{
		bodyheight 	= bodyheight_small;
		bodywidth	= bodywidth_small;
	}

	document.body.style.height 	= bodyheight;
	document.body.style.width 	= bodywidth;
	
	Debug( "SetBodySize, bodytype=" + bodytype );
	
	BodySize = bodytype;
	
	ResetSlices( BodySize );
}

// 2007.04.02 KJD: Set Debug text
function Debug( thisString )
{
	document.getElementById( 'DEVTEXT' ).innerHTML = thisString;
}

CheckStates();
